<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh/HowTos/SoftwareRAIDonCentOS5</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh/HowTos/SoftwareRAIDonCentOS5</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867">
<h1 id="A.2BWYJPVVco_CentOS_5_.2BTgqLvn9uTgBOKo9vTvZ4bHbYljVSFw-">如何在 CentOS 5 上设置一个软件硬盘阵列</h1>
<span class="anchor" id="line-4"></span><p class="line862">这篇文章探讨一个方法，可于安装时在没有真实硬盘阵列控制器的系统上创建一个软件（mdraid）RAID1。此方法<strong>没有</strong> CentOS 计划的支持，也<strong>不是</strong>一个适合普通用户的做法（请参阅下文的「计设考虑因素」备注）。此篇文章的作用是记录一个实验性质的做法，它的脆弱成果在内核更新后便不能更新。我们<strong>并不</strong>推荐它。多年的经验告诉我们，你很可能<strong>会</strong>忘记更新开机程序，因此损失数据的机会比硬盘失效的可能性更高。 <span class="anchor" id="line-5"></span><span class="anchor" id="line-6"></span><p class="line862">「不获支持」的意思就是：当你在 #centos IRC 频道上查询有关此篇文章时，频道上的常客将会告诉你它<strong>不获支持</strong>，及<strong>不要这样做</strong> <span class="anchor" id="line-7"></span><span class="anchor" id="line-8"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> 设计考虑因素：在 /boot 分区采用 RAID 是否明智？位于挂载点：<strong>/boot/</strong> 的内容普遍是于置于在一个<strong>原生</strong>（非 RAID）的分区内。它的尺寸相对较细，传统是 250 MB 之下。因此在安装或更新<strong>后</strong>，你可以简易地利用这样一个小脚本把内容复制到由 RAID 提供冗余的位置：{{{ # [ ! -d /root/boot_backup ] &amp;&amp; mkdir -p /root/boot_backup <span class="anchor" id="line-9"></span># rsync -a -v /boot/. /root/boot_backup/. }}} <span class="anchor" id="line-10"></span>这样你便能通过 RAID 保护该分区的副本。当然 RAID 并非备份的方案。采用此方法可避免下文介绍的<strong>杂牌</strong>及脆弱做法。 <span class="anchor" id="line-11"></span><span class="anchor" id="line-12"></span><div><table><tbody><tr>  <td style="background-color: #ff1480"><p class="line862"> <img alt="&lt;!&gt;" height="16" src="/moin_static1911/modern/img/attention.png" title="&lt;!&gt;" width="16" /> 这篇文章所描述的行动可以毁坏现有的文件系统。请先在一个测试设备上进行实验，并创建最新及可靠的备份，然后才正式执行。请勿盲目地剪贴指令，尤其是以 <em>root</em> 身份来执行，除非你清楚了解它们的效用。 </td>
</tr>
</tbody></table></div><span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span><p class="line874">这个做法意味着控制器会将原始块设备直接暴露给操作系统。它亦假设所涉及的设备是头两个 SATA 或 SCSI 硬盘，/dev/sda 及 /dev/sdb。若果是头两个平衡 ATA 硬盘，请将 /dev/sda 及 /dev/sdb 改为 /dev/hda 及 /dev/hdb（或者 /dev/sdc，如果是第二个主硬盘）。假如是其它设备，请适切地调整硬盘称谓。请按你的处境小心修改指令，切勿盲目地遵从下面的步骤。 <span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><p class="line874">要正确开机，/boot 必须位于非硬盘阵列或 RAID1 分区。RAID0、RAID5 及其它 RAID 类型不适用于 /boot，而 RAID0（没有冗余的条纹）则不推荐给重要的分区使用。只要满足了 /boot 的限制，主目录及其它分区便可以采用 RAID5 或其它类型；然而，这个样例不会涵盖那些选择。 <span class="anchor" id="line-17"></span><span class="anchor" id="line-18"></span><p class="line867"><strong>dd 这个指令及下面所描述的步骤将会毁灭硬盘上的所有数据。如果硬盘上藏有需用的数据，请将它们备份。</strong> <span class="anchor" id="line-19"></span><span class="anchor" id="line-20"></span><p class="line867">
<h2 id="A.2BeyxOAJDoTv0-">1. 第一部份</h2>
<span class="anchor" id="line-21"></span><ol type="1"><li>停用主机板或 RAID 控制器 BIOS 上的任何仿真的硬盘阵列，令它成为一个正常的控制器 —— 多数是 ATA 或 SATA，也有可能是 SCSI。假如之前采用的是仿真硬盘阵列，你或许须要盖过分区列表。切勿装入 RAID 驱动程序。以下指令可以于图像安装分割硬盘前在第二个虚拟控制台（Ctrl-Alt-F2）内执行；或者在安装媒体的修复模式中执行；又或者通过 LiveCD 来执行。设备内的分区表将会被清除，而硬盘上的所有数据将会被遗失！ <span class="anchor" id="line-22"></span><ul><li style="list-style-type:none">{{{dd if=/dev/zero of=/dev/sda bs=512 count=64 <span class="anchor" id="line-23"></span></li></ul></li></ol><p class="line874">dd if=/dev/zero of=/dev/sdb bs=512 count=64}}} <span class="anchor" id="line-24"></span><ol type="1"><li>开始以图像界面安装 CentOS。你可能需要用 "boot: linux nodmraid" 或在首个安装选单按 [Tab] 来加入 nodmraid 这个开机指令。 <span class="anchor" id="line-25"></span></li><li>自定分区并删除所有分区，包括 LVM，来作个新开始 <span class="anchor" id="line-26"></span></li><li>在 sda 及 sdb 上为 /boot 创建一个 ~100MB 的软件硬盘阵列分区 <span class="anchor" id="line-27"></span></li><li>在 sda 及 sdb 上为 swap 创建一个软件硬盘阵列分区。这个分区的尺寸视乎内存数量及个人首选。这个范件采用 1GB。这将会是个硬盘阵列式的 swap*** <span class="anchor" id="line-28"></span></li><li>在 sda 及 sdb 上为 / 创建一个软件硬盘阵列分区并用尽所有空间 <span class="anchor" id="line-29"></span></li><li>点击 RAID 键来创建一个硬盘阵列设备 <span class="anchor" id="line-30"></span></li><li>选择那两个 100MB 的分区，设置挂载点为 /boot，文件系统类型为 ext3，硬盘阵列类型为 RAID1（缺省设备名称是 md0），点击 OK <span class="anchor" id="line-31"></span></li><li>点击 RAID 键来创建一个硬盘阵列设备 <span class="anchor" id="line-32"></span></li><li>选择那两个 1GB 的分区，配置文件案系统类型为 swap，硬盘阵列类型为 RAID1（缺省设备名称是 md1），点击 OK <span class="anchor" id="line-33"></span></li><li>点击 RAID 键来创建一个硬盘阵列设备 <span class="anchor" id="line-34"></span></li><li>选择那两个大的分区，设置挂载点为 /，配置文件案系统类型为 ext3，硬盘阵列类型为 RAID1（缺省设备名称是 md2），点击 OK <span class="anchor" id="line-35"></span></li><li>你的分区已经创建好。你的划面应该看似以下样子： <span class="anchor" id="line-36"></span><ul><li style="list-style-type:none"><p class="line891"><strong>RAID 设备</strong> <span class="anchor" id="line-37"></span><span class="anchor" id="line-38"></span><span class="anchor" id="line-39"></span><span class="anchor" id="line-40"></span><pre><span class="anchor" id="line-1"></span>/dev/md0 ext3 [选择了] 100
<span class="anchor" id="line-2"></span>/dev/md1 swap [选择了] 1024
<span class="anchor" id="line-3"></span>/dev/md2 ext3 [选择了] [很多 GB]</pre><span class="anchor" id="line-41"></span><p class="line891"><strong>硬磁</strong> <span class="anchor" id="line-42"></span><span class="anchor" id="line-43"></span><span class="anchor" id="line-44"></span><span class="anchor" id="line-45"></span><span class="anchor" id="line-46"></span><span class="anchor" id="line-47"></span><span class="anchor" id="line-48"></span><span class="anchor" id="line-49"></span><span class="anchor" id="line-50"></span><pre><span class="anchor" id="line-1-1"></span>/dev/sda
<span class="anchor" id="line-2-1"></span>   /dev/sda1 /dev/md0 software RAID [未被选择] 100
<span class="anchor" id="line-3-1"></span>   /dev/sda2 /dev/md1 software RAID [未被选择] 1024
<span class="anchor" id="line-4"></span>   /dev/sda3 /dev/md2 software RAID [未被选择] [很多 GB]
<span class="anchor" id="line-5"></span>/dev/sdb
<span class="anchor" id="line-6"></span>   /dev/sdb1 /dev/md0 software RAID [未被选择] 100
<span class="anchor" id="line-7"></span>   /dev/sdb2 /dev/md1 software RAID [未被选择] 1024
<span class="anchor" id="line-8"></span>   /dev/sdb3 /dev/md2 software RAID [未被选择] [很多 GB]</pre><span class="anchor" id="line-51"></span><span class="anchor" id="line-52"></span></li></ul></li><li class="gap">点击 Next 进到 GRUB 引导程序划面 <span class="anchor" id="line-53"></span></li><li>缺省 GRUB 会安装到 /dev/sda，点击 Next <span class="anchor" id="line-54"></span></li><li>继续安装 CentOS，选择所需的组件 <span class="anchor" id="line-55"></span></li><li>当 CentOS 已完成安装并重新引导，请进到第二部份。切勿更新 CentOS；切勿做其它事情！ <span class="anchor" id="line-56"></span></li></ol><p class="line867">
<h2 id="A.2BeyxOjJDoTv0-">2. 第二部份</h2>
<span class="anchor" id="line-57"></span><p class="line874">这部份会确保 RAID1 /boot 的两个成员都可以用来开机。请在硬盘失效／更替后重复这个部份。 <span class="anchor" id="line-58"></span><span class="anchor" id="line-59"></span><p class="line867">
<h3 id="A.2BZbls1U4A_.2BIBQgFA_.2BXwBnOmX2dSg_GRUB">2.1. 方法一 —— 开机时用 GRUB</h3>
<span class="anchor" id="line-60"></span><p class="line874">在 GRUB 选单输入 "c" 选项进到 GRUB 的提示行，接着： <span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><ul><li style="list-style-type:none"><span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><span class="anchor" id="line-65"></span><span class="anchor" id="line-66"></span><pre><span class="anchor" id="line-1-2"></span>grub&gt; root (hd1,0)
<span class="anchor" id="line-2-2"></span>grub&gt; setup (hd1)
<span class="anchor" id="line-3-2"></span>grub&gt; root (hd0,0)
<span class="anchor" id="line-4-1"></span>grub&gt; setup (hd0)</pre><span class="anchor" id="line-67"></span></li></ul><p class="line874">按 ESC 键返回 GRUB 选单，然后正常开机。进行方法二里面的 1 及 5-8 步。 <span class="anchor" id="line-68"></span><span class="anchor" id="line-69"></span><p class="line867">
<h3 id="A.2BZbls1U6M_.2BIBQgFA_.2BVyiP0E9cTi12hHz7ft91KA_GRUB">2.2. 方法二 —— 在运作中的系统用 GRUB</h3>
<span class="anchor" id="line-70"></span><ol type="1"><li><p class="line862">确定你是 <a href="./zh(2f)TipsAndTricks(2f)BecomingRoot.html">root</a>。 <span class="anchor" id="line-71"></span></li><li>输入 "/sbin/grub" 这个指令，按 Enter <span class="anchor" id="line-72"></span></li><li>在 GRUB 的指令壳输入以下指令： <span class="anchor" id="line-73"></span><ul><li style="list-style-type:none"><span class="anchor" id="line-74"></span><span class="anchor" id="line-75"></span><span class="anchor" id="line-76"></span><span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><pre><span class="anchor" id="line-1-3"></span>grub&gt; device (hd0) /dev/sdb
<span class="anchor" id="line-2-3"></span>grub&gt; device (hd1) /dev/sda
<span class="anchor" id="line-3-3"></span>grub&gt; root (hd0,0)
<span class="anchor" id="line-4-2"></span>grub&gt; setup (hd0)
<span class="anchor" id="line-5-1"></span>grub&gt; root (hd1,0)
<span class="anchor" id="line-6-1"></span>grub&gt; setup (hd1)
<span class="anchor" id="line-7-1"></span>grub&gt; quit</pre><span class="anchor" id="line-81"></span></li></ul></li><li>祝你好运。输入 "reboot"，按 Enter。 <span class="anchor" id="line-82"></span></li><li>当开机完成后，进行系统更新。 <span class="anchor" id="line-83"></span></li><li>如果内核或 glibc 更新了，请重新开机。 <span class="anchor" id="line-84"></span></li><li>如果有新的内核，输入 "uname -a" 后按 Enter 来检查你的确在运用最新的内核。 <span class="anchor" id="line-85"></span></li><li>完成了！ <span class="anchor" id="line-86"></span></li></ol><p class="line867"><hr /><p class="line874"> <span class="anchor" id="line-87"></span><ul><li style="list-style-type:none"><p class="line862">这份指引是根据 <a class="http" href="http://www.centos.org/modules/newbb/viewtopic.php?viewmode=flat&amp;topic_id=19853&amp;forum=37">CentOS 论坛议题</a>引述 <a href="./TimVerhoeven.html">TimVerhoeven</a> 在 irc.freenode.net 上的 #centos 频道所提供的数据，吸纳了论坛用户及 <a class="http" href="http://lists.centos.org/mailman/listinfo/centos-docs">centos-docs</a> 上的反馈作出多番修饰而写成的。 <span class="anchor" id="line-88"></span><span class="anchor" id="line-89"></span></li><li class="gap" style="list-style-type:none">以上程序假设一个图像化的安装。在文字模式下创建 RAID-1 设备是可行的，但颇为冗长及苛刻。你首先要在硬盘上创建每个 RAID 成员分区，并且指定采用单一个硬盘。如果你不为分区个指定单一的硬盘（例如 sda 或 sdb），Disk Druid 似乎会在创建 RAID 设备时修改你的分配。在创建 RAID 设备的过程中，请确定你在每个硬盘上单单选择所需的 RAID 分区。 <span class="anchor" id="line-90"></span><span class="anchor" id="line-91"></span></li><li class="gap" style="list-style-type:none"><p class="line862">同一个方法应该可以应用在位于 RAID1 上的 /，而不须 /boot。这个 <a class="http" href="http://www.texsoft.it/index.php?c=hardware&amp;m=hw.storage.grubraid1&amp;l=it">Fedora 指南</a>的连结就采用了这个方法，它应该颇合用。这篇 Fedora 文章亦为了如何用 mdadm 进行修复提供了很好的指引。 <span class="anchor" id="line-92"></span></li><li style="list-style-type:none"><p class="line862">本 Wiki 内其它有关 RAID 的文章包括 <a href="./zh(2f)HowTos(2f)CentOS5ConvertToRAID.html">如何利用修复光盘将一个 CentOS 5 系统转换成 RAID1</a> 及 <a href="./zh(2f)HowTos(2f)Install_On_Partitionable_RAID1.html">如何在一个可分割的软件 RAID1 上安装 CentOS 5</a>。 <span class="anchor" id="line-93"></span></li><li style="list-style-type:none">一般有关软件硬盘阵列的文章： <span class="anchor" id="line-94"></span><ul><li style="list-style-type:none"><p class="line891"><a class="http" href="http://tldp.org/HOWTO/Software-RAID-HOWTO.html">http://tldp.org/HOWTO/Software-RAID-HOWTO.html</a> <span class="anchor" id="line-95"></span><a class="http" href="http://en.wikipedia.org/wiki/Mdadm">http://en.wikipedia.org/wiki/Mdadm</a> <span class="anchor" id="line-96"></span></li></ul></li><li style="list-style-type:none"><p class="line862">一篇不错的 Linux Journal 文章关于 <a class="http" href="http://www.linuxjournal.com/article/8874">修复 RAID 及 LVM2 扇区</a>。 <span class="anchor" id="line-97"></span><span class="anchor" id="line-98"></span></li><li class="gap"><p class="line862">* 有些控制器声称是硬件硬盘阵列，但仿似 winmodem 般须要用驱动程序来运作。这些控制器就是所谓的「仿真 RAID」或「冒牌货」，它们在 CentOS 上停用 RAID 功能会更佳。这篇<a class="http" href="http://www.brandonchecketts.com/archives/disabling-dmraid-fakeraid-on-centos-5">外置文章</a>颇详细地探讨这些议题。 <span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span></li><li class="gap"><p class="line862">** 欲得到有关硬盘列件的解释，请阅读 <a class="http" href="http://en.wikipedia.org/wiki/Redundant_array_of_independent_disks">Wikipedia 文章</a>，或在 google 上寻找其它精彩描述。要得更多针对企业级 Linux 5 的信息，请参阅部署指南的<a class="http" href="http://www.centos.org/docs/5/html/5.2/Deployment_Guide/ch-raid.html">「冗余硬盘阵列（RAID）」</a>部份或 CentOS 5 常见问题集内的<a class="http" href="http://wiki.centos.org/zh/FAQ/CentOS5#head-d9e6f2383c8c976a90228b4e680814f86e218e4e">「我如何在 CentOS 5 上安装一个软件硬盘阵列？」</a>。 <span class="anchor" id="line-101"></span><span class="anchor" id="line-102"></span></li><li class="gap">*** 另一个舍弃冗余来换取更佳性能和双倍调换空间，但沿用相同分区尺寸的做法，就是采用两个非硬盘阵列的分区。这样做的性能与 RAID0 相若，但就算一个硬盘坏了仍能捱得住，虽然只会剩下一半的调换空间。 <span class="anchor" id="line-103"></span><span class="anchor" id="line-104"></span></li><li class="gap">选择二：把剩下的空间放在另一个 RAID1，然后在 /dev/md1 上创建一个 LVM 扇区，把 /、swap、甚至 /home 或其它文件系统以逻辑扇区的型式创建在 LVM 内。请跳过第 1 分段余下的指引。 <span class="anchor" id="line-105"></span><span class="anchor" id="line-106"></span></li></ul><p class="line867"><hr /><p class="line874"> <span class="anchor" id="line-107"></span>这页的英文版由 <a href="./PhilSchaffner.html">PhilSchaffner</a> 创建及维护。欢迎其它拥有编辑权限的 Wiki 贡献者作出更正或添加。其它有意见的读者可以在我的 Wiki 页内找到联络数据。 <span class="anchor" id="line-108"></span><span class="anchor" id="line-109"></span><p class="line867"><small>Translation of revision 37</small> <span class="anchor" id="line-110"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
